#ifndef _TTYHANDLERS_H_INCLUDED_
#define _TTYHANDLERS_H_INCLUDED_

typedef unsigned char * tabcompletioncallback(unsigned char * curinp);

/* Sets up terminal modes on stdin, registers exit function.
 * Returns 1 if successful, or 0 if failed (e.g. if STDIN is not a terminal) */
int setupstdin(void);

/* Resets Terminal to values before setupstdin - you should not need to call
 * this manually for cleanup on exit, but you can. */
void resetstdin(void);

/* Adds one character to the input buffer.
 * Returns 1 if a command is complete (return hit), or 0 otherwise. */
int addtoinputbuf(unsigned char which);

/* Resets the input buffer (clears it). You have to do that manually after
 * a command completed */
void clearinputbuf(void);

/* Redraws the input line */
void redrawinputline(void);

/* Gets the inputline - YOU MUST NOT MODIFY THIS! */
unsigned char * getinputline(void);

/* Jumps to the beginning of the line on STDOUT */
void jmptocol1(void);

/* Clears to end of line on STDOUT */
void cleartoeol(void);

/* Generates a bell */
void makebell(void);

void registertabcompletioncallback(tabcompletioncallback * x);

#endif /* _TTYHANDLERS_H_INCLUDED_ */
